#include <bits/stdc++.h>
using namespace std;
long long n, q, d[10000008], p[10000008], u, br=1, ukupno, pojedeno,x=1, maks;
int main(){
    scanf("%lld%lld",&n,&q);
    for(int i=1; i<=n; i++){
        scanf("%lld%lld",&d[i],&p[i]);
        maks+=p[i];
    }
    for(int i=1; i<=q; i++){
        scanf("%lld",&u);
        if(u>maks){
            printf("%lld\n",maks);
            continue;
        }
        while(br<=u and br<=maks){
            if(br==d[x]){
                ukupno+=p[x];
                x++;
            }
            if(ukupno>0){
                pojedeno++;
                ukupno--;
            }
            br++;
        }
        printf("%lld\n",pojedeno);
    }
return 0;
}